; ********************************************
; DRIVERS FOR:
;
; Epson LQ (24-Pin) & compatibles
; IBM ProPrinter X24, XL24
; ********************************************
; 

 if (prn_mfg eq mfg_epson)
	PRN_GR	   EQU	GR_BIN OR GR_COLS ; We tell Epson # of COLUMNS
 else
	PRN_GR	   EQU	GR_BIN		  ; We tell IBM # of BYTES...
	GR_LENOFF  =	1		  ; ...plus one.
 endif
	PRINT_ALL  EQU	TRUE	; Can print all characters using quote
	PIN24	   EQU	3	; Uses 3 passes, 8 bits each.
	prn_chrset	= chrset_pc8
	prn_byte	= byte_vert

	;	Graphics Mode definitions.
	;

	;        prn                    (1/10")   
	;      # mode  rep rot pattern  x"   y" ; 
	GFXMAP 0,  0,   2,  1,       3, 80, 105	; (320x200)
	GFXMAP 1,  0,   3,  1,       4, 80, 105	; (640x200)
	GFXMAP 2,  1,   2,  0,       3, 80, 105	; (640x350)
	GFXMAP 3,  1,   2,  0,       4, 80, 105	; (640x480)
	GFXMAP 4,  1,   1,  0,       5, 80, 105	; (herc)
	GFXMAP X,  1,   1,  0,       8, 80, 105	; (reduce)
	GFXMAP 10, 0,   2,  0,       2, 80, 105	; (320x200)
	GFXMAP 11, 0,   1,  0,       2, 80, 105	; (640x200)
	GFXMAP 12, 1,   3,  1,       4, 80, 105	; (640x350)
	GFXMAP 13, 1,   2,  1,       4, 80, 105	; (640x480)
	GFXMAP 14, 1,   3,  1,       4, 80, 105	; (herc)
	GFXMAP 1X, 1,   1,  1,       8, 80, 105	; (reduce)
	gfxmap_end label word

	GMODES	LABEL	WORD
		PRNMODE	0, 120, 180
		PRNMODE 1, 180, 180
	MAXMODE	EQU	0

	; 3 bytes/column * 180 columns/inch * 8 inches:
	BUFLEN		EQU	PIN24*180*8

 if (prn_mfg eq mfg_epson)
	PMODE_PRT0	DW 5
			DB	27,'*'
			DB	33	; 120x180 dpi 24-pin Epson mode
	PMODE_LEN0	DW	?
 else
	PMODE_PRT0	DW 6
			DB	27,'[g'
	PMODE_LEN0	DW	?
			DB	9	; 120x180 dpi (IBM XL 24)
 endif
 if (prn_mfg eq mfg_epson)
	PMODE_PRT1	DW 5
			DB	27,'*'
			DB	39	; 180x180 dpi 24-pin Epson mode
	PMODE_LEN1	DW	?
 else
	PMODE_PRT1	DW 6
			DB	27,'[g'
	PMODE_LEN1	DW	?
			DB	11	; 180x180 dpi (IBM XL 24)
 endif

	EGADSTR GR_OFF,<13>		; Sent after each ribbon
	EGADSTR	CR,<13>			; CR only
	MLCRLF LABEL WORD		; Print after each graphics command
	EGADSTR CRLF,<13,10>

	; These printers can print codes < 32 with a special escape sequence.
	EGADSTR QUOTE_CHAR,<27,'^'>
	; Turn off condensed type and double-width:
	EGADSTR EXT_CHARS,<18,27,'W',0>
	; Set printer to graphics spacing.
 if (prn_mfg eq mfg_epson)
	; Epson LQ,
	; IBM ProPrinter, AGM *ON*
	;	Spacings are 1/60" (Esc-A) and 1/180" (Esc-3)
	EGADSTR GSETUP,<27,'3',24>
	; Reset printer to 1/6" (10/60") spacing:
	EGADSTR NSPACE,<27,'A',10,27,'2'>
 else
	; IBM ProPrinter, AGM *OFF*
	;	Spacings are 1/72" (Esc-A) and 1/216" (Esc-3)
	;	NOTE: 28/216" is really 0.1296", not 0.1333",
	;	but the printer apparently rounds it off.
	EGADSTR GSETUP,<27,'3',28>
	; Reset printer to 1/6" (12/72") spacing:
	EGADSTR NSPACE,<27,'A',12,27,'2'>
 endif

 IF (PRN_TYP AND TYP_COLOR)
	NBUFFERS EQU 4
	YELLOW LABEL WORD
	EGADSTR GR_YELLOW, <27,'r',4>	; Select yellow ribbon
	MAGENTA LABEL WORD
	EGADSTR GR_MAGENTA,<27,'r',1>	; Select magenta ribbon
	CYAN LABEL WORD
	EGADSTR GR_CYAN,   <27,'r',2>	; Select cyan ribbon
	BLACK LABEL WORD
	EGADSTR GR_BLACK,  <27,'r',0>	; Select black ribbon
 ELSE
	;	B & W printers - use text modes
	;	Text mode, Attribute definitions.
	TEXT_ATTRS LABEL WORD
		DW	text_nor	; 0
		DW	text_emph	; 1
		DW	text_undr	; 2
		DW	text_ital	; 3

	N_TEXT_ATTRS EQU (($-TEXT_ATTRS)/2)-1 ; normally 3

    if (prn_mfg eq mfg_epson)
	EGADSTR TEXT_NOR, <27,'-',0,27,'F',27,'5'> ; emph off,undr off,ital off
	EGADSTR TEXT_EMPH,<27,'E'>		; emphasized
	EGADSTR TEXT_UNDR,<27,'-',1>		; underline
	EGADSTR TEXT_ITAL,<27,'4'>		; italics
    else
	EGADSTR TEXT_NOR, <27,'I',0,27,'-',0,27,'F'> ; (Draft,10 CPI), Undr off, Emph off
	EGADSTR TEXT_EMPH,<27,'E'>		; emphasized
	EGADSTR TEXT_UNDR,<27,'-',1>		; underline
	EGADSTR TEXT_ITAL,<27,'I',2>		; NLQ Courier 10 CPI
    endif
 ENDIF
	;	8 bits/byte, MSB on top
	PATTERN 2, 2, 8
		db	11110000b
		db	00001111b
	PATTERN 3, 3, 8
		db	11000000b
		db	00111000b
		db	00000111b
	PATTERN 4, 4, 8
		db	11000000b
		db	00110000b
		db	00001100b
		db	00000011b
	PATTERN 5, 5, 8
		db	10000000b
		db	01100000b
		db	00011000b
		db	00000100b
		db	00000011b
	PATTERN 8, 8, 8
		db	10000000b
		db	01000000b
		db	00100000b
		db	00010000b
		db	00001000b
		db	00000100b
		db	00000010b
		db	00000001b
		db	0		; end of patterns

	PATTERN_200 EQU PATTERN_2 

  IF (PRN_TYP AND TYP_COLOR)	; Color printers:
	DITHER_LEVELS	EQU 4			; # of dither patterns
	DITHER_WIDTH	EQU 8			; bytes per pattern
	NDITHERS	EQU 1			; 1 dither table

	; Entries in this table are taken from 8-level table below

	DITHER_TABLE LABEL WORD
	 DB	   0,   0,   0,   0,   0,   0,   0,   0	; 0-Level Dither
	 DB	0AAH,   0,055H,   0,0AAH,   0,055H,   0 ; 2-
	 DB	0FFH,   0,0AAH,055H,0FFH,   0,0AAH,055H ; 4-
	 DB	0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH	; 7

	; Translate abstract colors	(--yymmcc)
	;    to physical ones		(kkccmmyy)
	COLOR_XLAT LABEL BYTE
		db	000h,010h,020h,030h,004h,014h,024h,034h
		db	008h,018h,028h,038h,00Ch,01Ch,02Ch,03Ch
		db	001h,011h,021h,031h,005h,040h,025h,035h
		db	009h,019h,029h,039h,00Dh,01Dh,02Dh,03Dh
		db	002h,012h,022h,032h,006h,016h,026h,036h
		db	00Ah,01Ah,080h,03Ah,00Eh,01Eh,02Eh,03Eh
		db	003h,013h,023h,033h,007h,017h,027h,037h
		db	00Bh,01Bh,02Bh,03Bh,00Fh,01Fh,02Fh,0C0h
  ELSE
	DITHER_LEVELS	EQU 8			; # of dither patterns
	DITHER_WIDTH	EQU 8			; bytes per pattern
	NDITHERS	EQU 1			; 1 dither table

	DITHER_TABLE LABEL WORD
	 DB	   0,   0,   0,   0,   0,   0,   0,   0	; 0-Level Dither
	 DB	0AAH,   0,   0,   0,055H,   0,   0,   0 ; 1-
	 DB	0AAH,   0,055H,   0,0AAH,   0,055H,   0 ; 2-
	 DB	0AAH,0AAH,   0,055H,0AAH,0AAH,   0,055H ; 3-
	 DB	0FFH,   0,0AAH,055H,0FFH,   0,0AAH,055H ; 4-
	 DB	0AAH,055H,0AAH,055H,0AAH,055H,0AAH,055H ; 5-
	 DB	0FFH,0AAH,055H,0FFH,0FFH,0AAH,055H,0FFH ; 6-
	 DB	0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH	; 7-
  ENDIF
	;
	;	End of Epson 24-Pin definition
	;
