; ********************************************
; DRIVERS FOR:
;
; IBM Color inkjet printer
; ********************************************
; 

	PRN_GR		= GR_BIN
	prn_byte	= byte_vert
	prn_chrset	= chrset_pc8

	;        prn                    (1/10")
	;      # mode  rep rot pattern  x"   y"
	GFXMAP 0,  0,   2,  0,     200, 80, 105
	GFXMAP 1,  0,   1,  0,     200, 80, 105
	GFXMAP 2,  0,   1,  0,     350, 80, 105
	GFXMAP 3,  0,   1,  0,     350, 80, 105
	GFXMAP 4,  0,   1,  0,     350, 80, 105
	GFXMAP X,  0,   1,  0,     350, 80, 105
	; No alternates available
	gfxmap_end label word

	;	GMODES: table of printer graphics modes

	GMODES	LABEL	WORD
		PRNMODE	0, 100, 96
	MAXMODE	EQU	0

	;	Graphics Mode definitions.
	PMODE_PRT0	DW 4
			DB	27,'K'
	PMODE_LEN0	DW	800		; 800 Dots/Line, 100 dpi

	egadstr ext_chars,<27,'6'>		; Character Set 2 (IBM PC)

	GSETUP	DW	6		; Initialize printer to 96 dpi
		DB	27,'[0',01,00,03 ; 100 x 96 dpi
	NSPACE	DW	6		; Reset printer to 72 dpi
		DB	27,'[0',01,00,01 ; 100 x 72 dpi

	EGADSTR GR_OFF,<13>		; Sent between 'ribbons'
	EGADSTR	CR,<13>			; CR only
	EGADSTR CRLF,<13,10>		; CR/LF pair
	EGADSTR MLCRLF,<27,'[U',01,00,08> ; Skip 8 dots

	;	Graphics bits are MSB on top

	PATTERN 200, 4, 8
		db	11000000b
		db	00110000b
		db	00001100b
		db	00000011b
	PATTERN	350, 8, 8
		db	10000000b
		db	01000000b
		db	00100000b
		db	00010000b
		db	00001000b
		db	00000100b
		db	00000010b
		db	00000001b
		db	0		; end of patterns

	NBUFFERS EQU	4
	GR_YELLOW LABEL WORD
	YELLOW	DW	6
		DB	27,'[M',01,00,6	; Select yellow ink
	GR_MAGENTA LABEL WORD
	MAGENTA	DW	6
		DB	27,'[M',01,00,3	; Select magenta ink
	GR_CYAN LABEL WORD
	CYAN	DW	6
		DB	27,'[M',01,00,5	; Select cyan ink
	GR_BLACK LABEL WORD
	BLACK	DW	6
		DB	27,'[M',01,00,0	; Select black ink

	;	Up to 800 Bytes across the page, plus two bytes of length
	BUFLEN	EQU	802

	DITHER_LEVELS	EQU 2			; 2 dither levels (on/off)
	DITHER_WIDTH	EQU 2			; bytes per pattern
	NDITHERS	EQU 1			; 1 dither tables

	DITHER_TABLE LABEL WORD
		DB	   0,   0	; 0-Level Dither
		DB	   0FFH,0FFH	; 1

	COLOR_XLAT LABEL BYTE
		db	000h,004h,004h,004h,002h,006h,006h,006h
		db	002h,006h,006h,006h,002h,006h,006h,006h
		db	001h,005h,005h,005h,003h,008h,004h,004h
		db	003h,002h,006h,006h,003h,002h,006h,006h
		db	001h,005h,005h,005h,003h,001h,005h,005h
		db	003h,003h,008h,007h,003h,003h,007h,007h
		db	001h,005h,005h,005h,003h,001h,005h,005h
		db	003h,003h,007h,007h,003h,003h,007h,008h

	; End of IBM Colorjet code
