; ********************************************
; DRIVERS FOR:
;
; MPI 99-G
; MPI 150-G
; ********************************************
; 

	prn_byte	= byte_vert
	PRN_GR	EQU	GR_BIT
	GR_BIT_VAL EQU	040H		; This bit must be set for gfx data
	prn_chrset	= chrset_ascii7	; Standard PC-8 -> ASCII

	;        prn                    (1/10")
	;      # mode  rep rot pattern  x"   y"
	GFXMAP 0,  0,   2,  0,     200, 80, 105
	GFXMAP 1,  0,   1,  0,     200, 80, 105
	GFXMAP 2,  0,   1,  0,     350, 80, 105
	GFXMAP 3,  0,   1,  0,     480, 80, 105
	GFXMAP 4,  0,   1,  0,     480, 80, 105
	GFXMAP X,  0,   1,  0,     480, 80, 105
	; No alternates available
	gfxmap_end label word

	;	GMODES: table of printer graphics modes

	GMODES	LABEL	WORD
		PRNMODE	0, 120, 72
	MAXMODE	EQU	0

	;	Graphics Mode definitions.

	PMODE_PRT0	DW	2
			DB	27,'W'
	PMODE_LEN0	DW	680	; (length placed here, ignored)

	GSETUP	DW	1		; Initialize printer to graphics spacing
		DB	31		; Send 'US' to set 85 dots/inch horiz
	NSPACE	DW	1		; Reset printer to 1/6" spacing
		DB	28		; Send 'FS' to set 10 cpi

	GR_OFF	DW	0		; N/A. GMODE turns graphics on;
					; MLCRLF turns it off.
	EGADSTR	CR,<13>			; CR only
	EGADSTR CRLF,<13,10>		; CR/LF pair
	EGADSTR MLCRLF,<'6'>		; this advances 6 microlines

	;	Text mode, Attribute definitions.  Not for color printers.

	TEXT_ATTRS LABEL WORD
		DW	text_nor	; 0
		DW	text_nor	; 1
		DW	text_under	; 2
		DW	text_nor	; 3

	N_TEXT_ATTRS EQU (($-TEXT_ATTRS)/2)-1

	EGADSTR TEXT_NOR,<15>	; no underline
	EGADSTR TEXT_UNDER,<14>	; underline

	;	MPI bits are MSB on top

	PATTERN	200, 3, 6
		db	00110000b
		db	00001100b
		db	00000011b
	PATTERN	350, 5, 6
		db	00110000b
		db	00001000b
		db	00000100b
		db	00000010b
		db	00000001b
	PATTERN 480, 9, 6
		db	00100000b
		db	00100000b
		db	00010000b
		db	00001000b
		db	00001000b
		db	00000100b
		db	00000010b
		db	00000010b
		db	00000001b
		db	0		; end of patterns

	;	Up to 680 Bytes across the page
	BUFLEN	EQU	680

	DITHER_LEVELS	EQU 2			; 2 dither levels (ON/OFF only)
	DITHER_WIDTH	EQU 2			; 2 bytes/level
	NDITHERS	EQU 1			; 1 dither table

	DITHER_TABLE LABEL WORD
		DB	0,0
		DB	0FFH,0FFH

	color_xlat label byte
		db	0,1,1,1,1,1,1,1

	; End of MPI code
