; ********************************************
; DRIVERS FOR:
;
; PCPI LaserImage 2000
; ********************************************
; 

	PRN_GR		= GR_DEC
	GR_DEC_DIGITS	= 3
	prn_byte	= byte_horiz
	prn_chrset	= chrset_ascii7	; Standard PC-8 -> ASCII

	;        prn                    (1/10")
	;      # mode  rep rot pattern  x"   y"
	GFXMAP 0,  0,   3,  0,     350, 80, 105
	GFXMAP 1,  0,   3,  0,     200, 80, 105
	GFXMAP 2,  0,   2,  1,     350, 80, 105
	GFXMAP 3,  0,   2,  1,     480, 80, 105
	GFXMAP 4,  1,   2,  0,     480, 80, 105
	GFXMAP X,  1,   2,  0,     480, 80, 105
	; No alternates available
	gfxmap_end label word

	;	Graphics Mode definitions.
	;

	GMODES	LABEL	WORD
		PRNMODE	0, 150, 150
		PRNMODE	1, 300, 300
	MAXMODE	EQU	1

	PMODE_PRT0 DW	14		; 150 dpi
		DB	27,7,'G'
	PMODE_LEN0	LABEL	BYTE
		DB	gr_dec_digits dup (0)	; Count goes here
		DB	',1,2,2;'

	PMODE_PRT1 DW	14		; 300 dpi
		DB	27,7,'G'
	PMODE_LEN1	LABEL	BYTE
		DB	gr_dec_digits dup (0)	; Count goes here
		DB	',1,1,1;'

	GSETUP	DW	0		; No setup codes needed
	NSPACE	DW	0		; End raster graphics transfer (unused)
	EGADSTR GR_OFF,<>		; No codes required after graphics xfer
	EGADSTR	CR,<13>			; CR only
	EGADSTR CRLF,<13,10>		; CR/LF pair
	EGADSTR MLCRLF,<>		; Nothing sent between gfx rows

	;	Laser printer - bytes run HORIZONTALLY.  Raster graphic
	;	commands produce one horizontal line of dots.
	;	The MSB is on the left of each byte.
	;	The REPEAT field above repeats each scan line, allowing
	;	dithering into successive print rows.

	PATTERN	200, 5, 8
		db	10000000b
		db	01100000b
		db	00011000b
		db	00000100b
		db	00000011b
	PATTERN 350, 3, 8
		db	11000000b
		db	00111000b
		db	00000111b
	PATTERN 480, 4, 8
		db	11000000b
		db	00110000b
		db	00001100b
		db	00000011b
		db	0		; end of patterns

	; Page print width = 8". Maximum dot density=300 dpi. 8 bits/byte.
	; Maximum buffer size: 300, plus 2 bytes of length.
	BUFLEN	EQU	302

	; 16 dither patterns: 8 shades & 8 patterns
	DITHER_LEVELS	EQU 16
	DITHER_WIDTH	EQU 1
	NDITHERS	EQU 4			; 4 dither tables

	DITHER_TABLE	LABEL WORD
		; 1st line byte patterns
		DB	000H,020H,022H,022H,0CCH,055H,0DDH,0FFH
		DB	0FFH,0AAH,080H,0CCH,0CCH,033H,0C3H,03CH
		; 2nd line
		DB	000H,002H,011H,088H,033H,0AAH,077H,0FFH
		DB	000H,0AAH,080H,0CCH,099H,099H,00FH,0C3H
		; 3rd line
		DB	000H,020H,044H,022H,0CCH,055H,0DDH,0FFH
		DB	000H,0AAH,080H,0CCH,033H,0CCH,03CH,0C3H
		; 4th line
		DB	000H,002H,088H,088H,033H,0AAH,077H,0FFH
		DB	0FFH,0AAH,080H,0CCH,066H,066H,0F0H,03CH

	TEXT_ATTRS LABEL WORD
		DW	text_nor	; 0
		DW	text_emph	; 1
		DW	text_edbl	; 2
		DW	text_edbl	; 3
	N_TEXT_ATTRS EQU (($-TEXT_ATTRS)/2)-1 ; normally 3

	EGADSTR	TEXT_NOR,<27,'&'>	; bold & shadow printing off
	EGADSTR TEXT_EMPH,<27,'O'>	; bold
	EGADSTR TEXT_EDBL,<27,'W'>	; shadow print

