	PAGE	88,132
	TITLE	GETBOX -- EGAD Screen Print (c) 1990, 1991 LS Software
	SUBTTL	Crop Box adjustment
;
;	EGAD Screen Print
;
;	COPYRIGHT (C) 1988, 1989, 1990, 1991 LS Software
;
;	Adjust Crop Box for EGAD Screen Print
;
; Routines used:
;	DLINE (X1, Y1, X2, Y2, Color)
;	PLOTPT (X1, Y1, color)
;	RESET ()
;	COLOR = READPT(X1,Y1);
;
	PUBLIC	GET_BOX
	EXTRN	PLOTPT:PROC
	EXTRN	READPT:PROC
	EXTRN	RESET:PROC
	EXTRN	DLINE:PROC
	EXTRN	READ_KBD:PROC
	EXTRN	TEST_KBD:PROC
	EXTRN	GET_MODE_PTR:PROC
INCLUDE	GLOBAL.INC

_DATA		SEGMENT WORD PUBLIC 'DATA'
	EXTRN	WORK_CFG:BYTE
	EXTRN	BOX_BUF:BYTE
	EXTRN	DISP_COLS:WORD, DISP_ROWS:WORD
	EXTRN	VIDEO_MODE:BYTE
	EXTRN	FORCE_MODE:BYTE
	EXTRN	VMODE_TYPE:WORD
_DATA		ENDS

	ASSUME	CS:_TEXT, DS:_DATA, SS:STACK, ES:_DATA

; Show Color Lines: Number of lines shown
NCOLORLINES	equ	8

; Keyboard definitions -- Table of key actions:

Escape_key	equ	0011bh		; Reject - abort
Enter_key	equ	01cffh		; Accept - x1 enlargement
nr_0_key	equ	00B30h		; Accept - Reduction
nr_1_key	equ	00231h		; Accept - x1 enlargement
nr_2_key	equ	00332h		; Accept - x2 enlargement
nr_3_key	equ	00433h		; Accept - x3 enlargement
nr_4_key	equ	00534h		; Accept - x4 enlargement
Home_key	equ	04700h		; Move left & up
UpArrow_key	equ	04800h		; move up
PgUp_key	equ	04900h		; Move right & up
LeftArrow_key	equ	04b00h		; move left
RightArrow_key	equ	04d00h		; move right
End_key		equ	04f00h		; move left & down
DownArrow_key	equ	05000h		; move down
PgDn_key	equ	05100h		; move right & down
Shift_Home_key	equ	04737h		; move whole left & up
Shift_UpArrow	equ	04838h		; move whole up
Shift_PgUp_key	equ	04939h		; move whole right & up
Shift_LeftArrow_key equ	04b34h		; move whole left
Shift_RightArrow_key equ 04d36h		; move whole right
Shift_End_key	equ	04f31h		; move whole left & down
Shift_DownArrow_key equ	05032h		; move whole down
Shift_PgDn_key	equ	05133h		; move whole right & down
Ins_key		equ	052ffh		; adjust upper-left
Del_key		equ	053ffh		; adjust lower-right
Plus_key	equ	04e2bh		; increase increment
Minus_key	equ	04a2dh		; decrease increment

C_key		equ	02effh		; 'c' - center
F_key		equ	021ffh		; 'f' - form feed
P_key		equ	019ffh		; 'p' - Force Portrait
R_key		equ	013ffh		; 'r' - Reverse colors
L_key		equ	026ffh		; 'l' - Force Landscape
V_key		equ	02fffh		; 'v' - Vertically centered

leftjust_key	equ	01affh		; '[' - left justify
rightjust_key	equ	01bffh		; ']' - right justify

shift_nr_1_key	equ	00221h		; Show Page 1
shift_nr_2_key	equ	00340h		; Show Page 2
shift_nr_3_key	equ	00423h		; Show Page 3
shift_nr_4_key	equ	00524h		; Show Page 4

show_color_key	equ	0353Fh		; Show colors ('?')

tab_key		equ	00Fffh		; Tab
f10_key		equ	044ffh		; F10 toggles forced gfx/text/[normal]
f9_key		equ	043ffh		; F9 always goes to Normal mode

@print_msg	macro todo
	mov	dx,offset todo
	mov	ah,l_print
	int	dos_int
	endm

@drawline macro xa,ya,xb,yb,colr
	push	colr
	push	yb
	push	xb
	push	ya
	push	xa
	call	near ptr dline
	endm

_DATA	SEGMENT

	align	2

key_mapping_table label word
	dw	Enter_key,		got_enter_key		; 1x
	dw	nr_0_key,		got_enter_reduce_key	; reduce
	dw	nr_1_key,		got_enter_15_key	; 1.5x
	dw	nr_2_key,		got_enter_num_key	; 2x
	dw	nr_3_key,		got_enter_num_key	; 3x
	dw	nr_4_key,		got_enter_num_key	; 4x
	dw	Minus_key,		got_minus_key
	dw	Plus_key,		got_plus_key
	dw	Escape_key,		skip
	dw	Home_key,		got_home_key
	dw	End_key,		got_end_key
	dw	Uparrow_key,		got_uparrow_key
	dw	Downarrow_key,		got_downarrow_key
	dw	Leftarrow_key,		got_leftarrow_key
	dw	Rightarrow_key,		got_rightarrow_key
	dw	PgDn_key,		got_PgDn_key
	dw	PgUp_key,		got_PgUp_key
	dw	Ins_key,		got_ins_key
	dw	Del_key,		got_Del_key
	dw	Shift_Home_key,		got_Shift_Home_key
	dw	Shift_UpArrow,		got_Shift_UpArrow
	dw	Shift_PgUp_key,		got_Shift_PgUp_key
	dw	Shift_LeftArrow_key,	got_Shift_LeftArrow_key
	dw	Shift_RightArrow_key,	got_Shift_RightArrow_key
	dw	Shift_End_key,		got_Shift_End_key
	dw	Shift_DownArrow_key,	got_Shift_DownArrow_key
	dw	Shift_PgDn_key,		got_Shift_PgDn_key
	dw	show_color_key,		show_colors
	dw	F_key,			got_F_key
	dw	L_key,			got_L_key
	dw	P_key,			got_P_key
	dw	R_key,			got_R_key
	dw	tab_key,		got_tab_key
	dw	C_key,			got_c_key
	dw	leftjust_key,		got_leftjust_key
	dw	rightjust_key,		got_rightjust_key
	dw	V_key,			got_v_key
 IFNDEF LIMITED
	; These keystrokes are not available in the "OEM" version.
	dw	shift_nr_1_key,		got_shift_nr_key
	dw	shift_nr_2_key,		got_shift_nr_key
	dw	shift_nr_3_key,		got_shift_nr_key
	dw	shift_nr_4_key,		got_shift_nr_key
	dw	f10_key,		got_f10_key
	dw	f9_key,			got_f9_key
 ENDIF
key_map_entries dw (key_map_entries-key_mapping_table)/4

color_ul dw	?	; Color of upper-left corner
color_lr dw	?	; Color of lower-right corner

corner  db	?	; 0xff if adjusting lower right corner

box_drawn db	0

; For SAVE & RESTORE functions:
xinc	dw	?
yinc	dw	?

; For the Color Sample function:
maxc	db	?

_DATA	ENDS

_TEXT	SEGMENT

; Routine to show screen dump extent box and allow user
; to select area to dump.

GET_BOX PROC
	push	ds
	push	es

	push	ds	; ES = DS
	pop	es

	mov	box_drawn,0	; Box not on screen
got_del_key:			; Adjust lower right corner
	mov	corner,0ffh	; Always start at lower right

next_key_draw:
	call	test_kbd	; If key waiting, don't save or draw box
	jnz	next_key

	call	near ptr save_box
	; It is possible to stop here if key pressed, but this results
	; in crop boxes NEVER being drawn while adjusting. wl 12/91
	call	near ptr draw_box
	mov	box_drawn,1	; box drawn

; Get the next user input and process key selection

next_key:
	call	read_kbd
	mov	si,offset key_mapping_table
	sub	bx,bx		; bx+si Points to start of table
	mov	cx,key_map_entries
next_1:	cmp	ax,[bx+si]	; test keystroke
	je	next_do
	cmp	byte ptr [bx+si],0FFh	; Allow any ASCII for this scancode?
	jne	next_check
	cmp	byte ptr [bx+si+1],ah	; Check scan-code is same
	je	next_do
next_check:
	add	bx,4		; go to next keystroke/jump pair
	loop	next_1
	jmp	next_key	; illegal key -- ignore

; restore box and perform action

next_do:
	test	box_drawn,0ffh	; If box is drawn...
	jz	next_do1
	push	ax		; Preserve key code for exit logic
	push	bx
	push	si
	call	near ptr rest_box ; restore it.
	pop	si
	pop	bx
	pop	ax
	mov	box_drawn,0	; Box not drawn
next_do1:
	jmp	[bx+si+2]	; "Do" the jump from table

; --------------------

got_home_key:
	call	near ptr go_up		; Falls through
got_leftarrow_key:
	call	near ptr go_left
	jmp	next_key_draw
got_PgUp_key:
	call	near ptr go_right	; Falls through
got_uparrow_key:
	call	near ptr go_up
	jmp	next_key_draw
got_PgDn_key:
	call	near ptr go_down	; Falls through
got_rightarrow_key:
	call	near ptr go_right
	jmp	next_key_draw
got_end_key:
	call	near ptr go_left	; Falls through
got_downarrow_key:
	call	near ptr go_down
	jmp	next_key_draw

Got_Shift_Home_key:
	call	near ptr box_up		; Falls through
Got_Shift_LeftArrow_key:
	call	near ptr box_left
	jmp	next_key_draw
Got_Shift_PgUp_key:
	call	near ptr box_right	; Falls through
Got_Shift_UpArrow:
	call	near ptr box_up
	jmp	next_key_draw
Got_Shift_PgDn_key:
	call	near ptr box_down	; Falls through
Got_Shift_RightArrow_key:
	call	near ptr box_right
	jmp	next_key_draw
Got_Shift_End_key:
	call	near ptr box_left	; Falls through
Got_Shift_Downarrow_key:
	call	near ptr box_down
	jmp	next_key_draw

got_plus_key:
	mov	al,byte ptr work_cfg.incr
	shl	al,1
	jmp	short save_incr

got_minus_key:
	mov	al,byte ptr work_cfg.incr
	shr	al,1
save_incr:
	jz	sv1
	mov	byte ptr work_cfg.incr,al
sv1:	jmp	next_key_draw

got_tab_key:
	not	corner
	jmp	next_key_draw

got_ins_key:
	mov	corner,0
	jmp	next_key_draw

; This code is actually performed at the top of this routine...
;
; got_del_key:
;	mov	corner,0ffh
;	jmp	next_key_draw

 IFNDEF LIMITED
got_shift_nr_key:
	mov	al,ah
	dec	al	; '1' key shows page 0
	dec	al

	mov	ah,5
	int	vid_int
	jmp	next_key_draw
 ENDIF

got_l_key:
	mov	ax,2	; Landscape
	jmp	short save_orient

got_p_key:
	mov	ax,1	; Portrait
save_orient:
	mov	work_cfg.orient,ax
	jmp	next_key_draw

got_leftjust_key:
	mov	work_cfg.centering,JUST_LEFT	; Left justify
	jmp	next_key_draw

got_c_key:
	mov	work_cfg.centering,JUST_CENTER	; Center
	jmp	next_key_draw

got_rightjust_key:
	mov	work_cfg.centering,JUST_RIGHT	; Right justify
	jmp	next_key_draw

got_v_key:
	mov	work_cfg.vcentering,JUST_CENTER	;Center vertical justify
	mov	work_cfg.do_ff,PG_RESET_BEFORE + PG_FF_AFTER ; Force reset before, eject after
	jmp	next_key_draw

got_r_key:
	xor	work_cfg.tsrflags,TSRF_REVCOLOR	; Toggle Reverse flag
	jmp	next_key_draw

 IFNDEF LIMITED
;
; The F10 key toggles between Forced Text, Forced Graphics, and Normal modes.
; F9 always goes to Normal mode (and thus restores crop box to full size.)
;
got_f10_key:
	inc	force_mode		; Toggle between FORCE_TEXT,
	cmp	force_mode,FORCE_GFX	; FORCE_GFX, and FORCE_NONE.
	jbe	f10_save
got_f9_key:				; Shift-F10 could reset to NORMAL
	xor	ax,ax			; Reset to FORCE_NONE
	mov	force_mode,ah
f10_save:
	sub	ax,ax			; Reset to whole-screen crop box
	mov	work_cfg.x2,ax
	mov	work_cfg.y2,ax
	mov	ax,XMODE_KEY
	jmp	short skip
 ENDIF

got_f_key:
	xor	ax,ax
	mov	work_cfg.do_ff,PG_FF_AFTER + PG_DONT_PRINT ; Force a form-feed
	mov	ax,Enter_key		; Pretend user pressed RETURN
	; Falls through:

got_enter_reduce_key:
	sub	bl,bl			; 0 = reduction
	jmp	short got_ek0

got_enter_15_key:
	mov	bl,5			; 1.5x enlargement
	jmp	short got_ek0

got_enter_key:
	mov	al,1			; ENTER = Normal (1x)
	; Fall thru:
got_enter_num_key:
	mov	bl,al			; Get ASCII character
	and	bl,0fh			; Make it 0..9
	; Fall thru:
got_ek0:
	mov	ax,Enter_key		; act like ENTER pressed
	sub	bh,bh
	mov	work_cfg.enlarge,bx	; save factor
skip:
; End of process, return exit key code
	pop	es
	pop	ds
	retn
;
; Routines to process basic movements

;		RIGHT & LEFT

go_right:
	mov	ax,work_cfg.incr
	jmp	short go_lr

go_left:
	mov	ax,work_cfg.incr
	neg	ax

go_lr:	cmp	corner,0
	je	go_lr1
	add	work_cfg.x2,ax
	retn
go_lr1:	add	work_cfg.x1,ax
	retn
	
;		UP & DOWN

go_up:
	mov	ax,work_cfg.incr
	neg	ax
	jmp	short go_ud

go_down:
	mov	ax,work_cfg.incr
go_ud:
	cmp	corner,0
	je	go_ud1
	add	work_cfg.y2,ax
	retn
go_ud1:	add	work_cfg.y1,ax
	retn

;		BOX LEFT & RIGHT

box_left:
	mov	ax,work_cfg.incr
	neg	ax
	jmp	short box_lr
box_right:
	mov	ax,work_cfg.incr
box_lr:
	mov	bx,work_cfg.x1
	mov	cx,work_cfg.x2
	add	bx,ax
	add	cx,ax
	call	near ptr test_x_stop
	mov	work_cfg.x1,bx
	mov	work_cfg.x2,cx
	retn

;		BOX UP & DOWN

box_up:
	mov	ax,work_cfg.incr
	neg	ax
	jmp	short box_ud
box_down:
	mov	ax,work_cfg.incr
box_ud:
	mov	bx,work_cfg.y1
	mov	cx,work_cfg.y2
	add	bx,ax
	add	cx,ax
	call	near ptr test_y_stop
	mov	work_cfg.y1,bx
	mov	work_cfg.y2,cx
	retn

test_x_stop:
; x1 is in bx, x2 is in cx
	mov	dx,disp_cols	; Upper bound is # of columns
	jmp	short test_stops

test_y_stop:
; y1 is in bx, y2 is in cx
	mov	dx,disp_rows	; Upper bound is # of rows

test_stops:
; if p1 (x1 or y1) hits lower bound, set to lower bound.
; if p2 (x2 or y2) hits upper bound, set to upper bound.
	dec	dx		; Example: If width=640, upper bound=639.
	cmp	cx,dx		; Compare p2 to upper bound
	jle	test_1		; If within bounds, test p1 next
	sub	cx,dx		; CX is temporary adjustment
	sub	bx,cx		; Adjusted p1
	mov	cx,dx		; p2 (p2) at end
	retn
test_1:	sub	dx,dx		; DX = lower bound (0)
	cmp	bx,dx		; is p1 less than lower bound?
	jge	test_ret	; no, all is ok.
	sub	cx,bx		; cx = width (height)
	mov	bx,dx		; bx = lower bound
test_ret:
	retn

show_colors:
	call	get_mode_ptr
	test	cl,vm_text
	jnz	show_color_exit	; Mode is text: ignore.
	sub	ax,ax			; AX = 0
	mov	bx,ax			; BX = 0
	call	readpt			; Sets AH = actual maximum color for this mode
	and	ah,31			; Limit to showing 32 colors
	mov	maxc,ah

	mov	di,offset box_buf	; Memory save area
	mov	dx,offset saveit
	call	show_color_lines

	sub	ax,ax		; Y position
	mov	cx,NCOLORLINES	; # of Scan Lines
show_draw_loop0:
	sub	bx,bx		; Color # (* 16 = X position)
show_draw_loop:
	push	ax
	push	bx
	push	cx
	
	push	bx		; Arg 1 = color
	mov	cl,3		; (was 4 -- wl 01/25/95)
	shl	bx,cl		; Left side = color * 16
	mov	dx,bx
	add	bx,7		; Right side = color * 16 + 7 (was 15)
	push	ax		; Arg 2 = Y
	push	bx		; Arg 3 = X2
	push	ax		; Arg 4 = Y
	push	dx		; Arg 5 = X1
	call	near ptr dline	

	pop	cx
	pop	bx
	pop	ax

	inc	bx
	cmp	bl,maxc		; Compare to max color # (1, 3, 15)
	jle	show_draw_loop	; Do all colors on each row

	inc	ax		; Increment row #
	loop	show_draw_loop0

	call	read_kbd	; Get a key

	mov	si,offset box_buf
	mov	dx,offset restoreit
	call	show_color_lines
show_color_exit:
	jmp	next_key_draw

; Saves, or restores, the lines where the color chart goes.
show_color_lines:
	push	bp
	 mov	bp,dx		; Function address
	 mov	cx,NCOLORLINES
color_line_loop:
	 push	cx
	  mov	bx,cx		; Y coordinate
	  dec	bx		;   = count - 1
	  sub	ax,ax		; X = 0
	  sub	cx,cx		; horizontal
	  mov	dx,255
	  call	bp
	 pop	cx
	 loop	color_line_loop
	pop	bp
	retn

;
; Check to ensure crop box is within screen limits.
;
test_limits:
	mov	ax,disp_cols	; Test X limits
	mov	cx,work_cfg.x1
	mov	dx,work_cfg.x2
	call	test_limit
	mov	ax,MAX_X_SIZE
	call	near ptr test_maxbox
	mov	work_cfg.x1,cx	; Save results
	mov	work_cfg.x2,dx

	mov	ax,disp_rows	; Test Y limits
	mov	cx,work_cfg.y1
	mov	dx,work_cfg.y2
	call	test_limit
	mov	ax,MAX_Y_SIZE
	call	near ptr test_maxbox
	mov	work_cfg.y1,cx	; Save results
	mov	work_cfg.y2,dx
	retn

; Test crop-box to ensure it does not exceed maximum crop size
; (determined by memory to save crop box data!)
;
test_maxbox proc near
	add	ax,cx
	cmp	dx,ax
	jle	test_max_ok
	mov	dx,ax
test_max_ok:
	retn
test_maxbox endp

; Test either X1,X2 or Y1,Y2 to see whether within limits.
;
; Input: p1 (X1 or Y1)	in CX
;	 p2 (X2 or Y2)	in DX
;	 Min value	1
;	 Max value	in AX
; Output: CX, DX updated
;
; If top/left side (in CX) and bottom/right side (in DX) cross over, then
; 'corner' is examined to see which one should remain fixed.
;
test_limit:
	dec	ax		; Example: if width=640, max=639.
	cmp	cx,0
	jl	p1_s		; p1 too small?
	cmp	cx,ax
	jbe	p1_ok		; p1 too big
	mov	cx,ax		; Reset to high limit
	jmp	short p1_ok
p1_s:	sub	cx,cx		; Reset p1 to low limit
p1_ok:	cmp	dx,cx		; p2 larger than p1?
	jge	p1_p2
	cmp	corner,0	; 0 => working on left & top
	je	p2p1
	mov	dx,cx		; UL corner, p1 is limit
	jmp	short p1_p2
p2p1:	mov	cx,dx		; LR corner, p2 is limit
p1_p2:	cmp	dx,0
	jl	p2_s		; p2 too small?
	cmp	dx,ax
	jbe	p2_ok		; p2 too big?
	mov	dx,ax		; Reset to high limit
	jmp	short p2_ok
p2_s:	mov	dx,cx		; Reset to low limit
p2_ok:	retn

;
; Routines to save and restore screen
;
save_box:
	mov	di,offset box_buf
	call	near ptr test_limits
	push	bp
	 mov	bp,offset saveit
	 call	do_box
	pop	bp
	retn

rest_box:
	mov	si,offset box_buf
	push	bp
	 mov	bp,offset restoreit
	 call	do_box
	pop	bp
	retn

do_box:
	; Save TOP line
	mov	bx,work_cfg.y1		; Top
	sub	cx,cx			; Horizontal
	mov	ax,work_cfg.x1		; Left...
	mov	dx,work_cfg.x2		; ...to Right
	call	bp
	; Save RIGHT line
	mov	ax,dx			; Right
	inc	cx			; vertical
	; mov	bx,work_cfg.y1		; top...
	mov	dx,work_cfg.y2		; ...to bottom
	call	bp
	; Save BOTTOM line 
	cmp	bx,dx			; Is Y1 = Y2?
	je	no_boxbtm
	mov	bx,work_cfg.y2		; Bottom
	sub	cx,cx			; horizontal
	mov	ax,work_cfg.x1		; Left...
	mov	dx,work_cfg.x2		; ...to Right
	call	bp
no_boxbtm:
	; Save LEFT line
	mov	ax,work_cfg.x1		; X1
	cmp	ax,work_cfg.x2		; Is X1 = X2?
	je	no_boxlft
	mov	dx,bx			; Y2
	mov	bx,work_cfg.y1		; Y1
	mov	cl,1			; vertical
	call	bp
no_boxlft:
	cmp	bp,offset restoreit
	jne	no_reset
	call	near ptr reset		; RESET when restoring
no_reset:
	retn
;
; Draws the crop box
;
draw_box:
	mov	di,offset box_buf
	mov	ax,work_cfg.colora
	mov	bx,work_cfg.colorb
	cmp	corner,0
	jz	do_dr
	xchg	ax,bx
do_dr:	mov	color_ul,ax
	mov	color_lr,bx

	@drawline work_cfg.x1,work_cfg.y1,work_cfg.x2,work_cfg.y1,color_ul ; Top
	@drawline work_cfg.x1,work_cfg.y1,work_cfg.x1,work_cfg.y2,color_ul ; Left
	@drawline work_cfg.x2,work_cfg.y1,work_cfg.x2,work_cfg.y2,color_lr ; Right
	@drawline work_cfg.x1,work_cfg.y2,work_cfg.x2,work_cfg.y2,color_lr ; Bottom
	retn
;
GET_BOX ENDP

SAVEIT	proc	near
	; ENTRY:
	;	AX = Starting X coordinate
	;	BX = Starting Y coordinate
	;	CX = 0 for Horizontal save, 1 for vertical save
	;	DX = Ending X or Y coordinate
	;	DI = Pointer to pixel save buffer
	; EXIT:
	;	DI = Points to next free byte in buffer
	; USES:	none
	push	ax
	push	bx
	push	cx
	push	dx
	call	saverestargs
	jcxz	save_exit
	; AX = X position
	; BX = Y position
	; CX = count of pixels to save
	; XINC, YINC = X & Y increments
save_loop:
	push	ax
	push	bx
	 call	near ptr readpt	; Read this pixel's color
	 stosb
	pop	bx
	pop	ax
	add	ax,xinc
	add	bx,yinc
	loop	save_loop
save_exit:
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	retn
SAVEIT	ENDP

RESTOREIT proc	near
	; ENTRY:
	;	AX = Starting X coordinate
	;	BX = Starting Y coordinate
	;	CX = 0 for Horizontal save, 1 for vertical save
	;	DX = Ending X or Y coordinate
	;	DI = Pointer to pixel save buffer
	; EXIT:
	;	DI = Points to next free byte in buffer
	; USES:	none
	push	ax
	push	bx
	push	cx
	push	dx
	call	saverestargs
	jcxz	rest_exit
	; AX = X position
	; BX = Y position
	; CX = count of pixels to save
	; XINC, YINC = X & Y increments
rest_loop:
	push	ax
	push	bx
	 mov	dx,cx		; save count in DX
	 xchg	ax,cx		; X in CL
	 lodsb			; Previous color
	 xchg	ax,cx		; Color in CL, X in AL
	 call	near ptr plotpt	; Plot it color
	 mov	cx,dx		; count in CX
	pop	bx
	pop	ax
	add	ax,xinc
	add	bx,yinc
	loop	rest_loop
rest_exit:
	jmp	save_exit	; same code...
;	pop	dx
;	pop	cx
;	pop	bx
;	pop	ax
;	retn
RESTOREIT ENDP

SAVERESTARGS PROC NEAR
	; ENTRY:
	;	AX = Starting X coordinate
	;	BX = Starting Y coordinate
	;	CX = 0 for Horizontal save, 1 for vertical save
	;	DX = Ending X or Y coordinate
	; EXIT:
	;	AX = X position
	;	BX = Y position
	;	CX = pixel count
	;	XINC, YINC = X & Y increments
	mov	yinc,cx		; Y increment
	xor	cl,1		; Flip the bit
	mov	xinc,cx		; X increment = 1 - Y inc.
	jcxz	args_v		; Now CX=0 if vertical
	; Horizontal line. 
	sub	dx,ax		; DX = X2 - X1
	jmp	short args_hv
	; Vertical line. Actually do from Y1+1 to Y2-1, so as not to
	; interfere with horizontal elements.
args_v:	inc	bx
	dec	dx	
	sub	dx,bx		; DX = Y2 - Y1
args_hv:
	mov	cx,dx		; Count of pixels to save
	inc	cx		; Include last pixel
	js	args_neg	; OK if count>=0.
	RETN
args_neg:			; Count < 0!
	sub	cx,cx		; Make count = 0
	retn
SAVERESTARGS ENDP

_TEXT	ENDS
	END
