SHOWIT	MACRO	exp,val
	IF2
	%OUT	exp = val
	ENDIF
	ENDM

SHOMODE	MACRO	modeno,wid,hite
	IF2
	%OUT	Printer mode &modeno: page size (screen pixels) = &wid x &hite
	ENDIF
	ENDM

EGADSTR	MACRO	i_labl,i_text
	LOCAL t_start,t_end
  IFNB <i_text>
   i_labl  DW	 t_end-t_start
   t_start DB	 i_text
   t_end   LABEL BYTE
  ELSE
   i_labl  DW	 0
  ENDIF
	ENDM

;	PRNMODE
;
;	Macro to define printer resolutions.
;
;	For example, with modenum = 0, the macro will equate
;	RESX0 and RESY0 to X & Y resolution of mode 0;
;	assumes string to print is PMODE_PRT0, and area to store
;	length is PMODE_LEN0.
;
PRNMODE MACRO modenum, xres, yres
	DW	PMODE_PRT&modenum, PMODE_LEN&modenum
	DW	xres, yres
RESX&modenum EQU xres
RESY&modenum EQU yres
	ENDM

;	GFXMAP
;
;	Macro to create GMAP array.
;
;	Arguments are mode #, printer mode to use, repeat
;	factor, rotation, pattern, and page size in 1/10"
;
;	GMAP array is used to map screen modes to printer resolutions.
;
;	Screen size  -> Printer resolution mapping
;	-----------	--------------------------
;	320x200		GMAP0
;	640x200		GMAP1
;	640x350		GMAP2
;	640x480		GMAP3
;	(reduction)	GMAPX
;

GFXMAP	MACRO nmode, pmode, rept, rotate, pattern, xin, yin
	LOCAL xdots, ydots

  IFDEF HORIZ_BYTES
   xdots equ ((((RESX&pmode * xin)/ PAT_BITS_&pattern)* PAT_BYTES_&pattern)/10)-1
   ydots equ ((RESY&pmode * yin)/rept/10)-1
  ELSE
   xdots equ ((RESX&pmode * xin)/rept/10)-1
   ydots equ ((((RESY&pmode * yin)/ PAT_BITS_&pattern)* PAT_BYTES_&pattern)/10)-1
  ENDIF

  GMAP&nmode LABEL WORD
  IF rotate
	DW	ydots, xdots
	SHOMODE	nmode,%(ydots),%(xdots)
  ELSE
	DW	xdots, ydots
	SHOMODE	nmode,%(xdots),%(ydots)
  ENDIF
	DW	pmode, rept
	DW	rotate, PATTERN_&pattern
	DW	xin, yin
	ENDM

;
;	Define a pattern.
;	Arguments are: name of pattern, length of pattern (how many
;	screen pixels are packed into each byte), and number of printer
;	bits used per byte (usu. 8).
;
;	Note: To determine the size of pattern required for a given screen
;	mode, do this calculation: (for Non-Rotated printouts)
;
;	  screen_x_dots / printer_xdpi * 3 / 4	= yinches
;	  yinches * printer_ydpi		= y_prn_dots
;	  screen_y_dots / y_prn_dots		= ratio
;	  ratio * prn_ndatabits_per_byte	= Required Pattern Size
;
;	(For Rotated printouts, switch screen_x/y_dots & use 4/3 not 3/4)
;
PATTERN	MACRO	name, nbytes, nbits
 PAT_BYTES_&name EQU nbytes		; Number of data bytes which follow
 PAT_BITS_&name  EQU nbits		; # of printer bits used
	DB	nbits			; # of bits used
 PATTERN_&name   LABEL BYTE
	DB	nbytes			; # of pattern bytes
	ENDM
