	PAGE	88,132
	TITLE	VIDEO_Z -- EGAD Screen Print (c) 1991 LS Software
	SUBTTL	Z-100 Video / Keypad / Printer Support
;
;	EGAD Screen Print
;
;	COPYRIGHT (C) 1988, 1989, 1990, 1991 LS Software
;
	PUBLIC  READPT, PLOTPT, RESET
	PUBLIC	GETMODE, BEEP
	PUBLIC	TEST_KBD, READ_KBD, KBD_SETUP, KBD_RESET

	PUBLIC	COPYRIGHT_MSG, DEFAULT_PRN
	PUBLIC	VIDEO_MODE, VIDEO_PAGE
	PUBLIC	DISP_ROWS, DISP_COLS, BYTES_ROW
	PUBLIC	FORCE_MODE

INCLUDE	GLOBAL.INC

	ASSUME	CS:_TEXT, DS:_DATA, SS:STACK, ES:_DATA

START_DATA	SEGMENT	WORD PUBLIC 'INIT'
COPYRIGHT_MSG LABEL BYTE
	DB	13,10
	DB	'EGAD -- Z-100 Screen Print  Copyright (c) 1990-1992',13,10
	DB	'   LS Software',9,9,9,'Driver for: $'
START_DATA	ENDS

_DATA	SEGMENT
;

VPORT	EQU	0D8H	; Video RAM access port
Z_MODE	EQU	0BH	; Z-100 Video pseudo-mode

	even

;
; Video Mode Characteristics:
;
disp_cols	dw	0	; Display columns
disp_rows	dw	0	; Display rows
bytes_row	dw	0	; Bytes per row
video_mode	db	?	; Video mode
video_page	db	?	; Video page
scans_char	db	9	; Displayed scan lines per character
force_mode	db	0
;
; Environment characteristics:
;
default_prn DW	0	; Z-100 printer *MUST* be 0!!

MONOCH	DB	0	; If monochrome system, all write's must be color 7
			; (this value is OR'ed into all Write colors)
VRAM	DB	?	; Previous video RAM access mode (port VPORT)
COLR	DB	?

LAST_Y	DW	-1	; GET_ADDRESS maintains this "last Y value" --
			; if it gets two consecutive requests for the same
			; Y value point, it saves time & eliminates the
			; divisions &c.
LAST_ANS DW	?	; If Y passed to GET_ADDRESS = LAST_Y, the scan line
			; begins at offset LAST_ANS.


BLUE	EQU	1	; Bits in color numbers
RED	EQU	2
GREEN	EQU	4

ZBIOS_SEG   DW	?	; Segment of BIOS save area

scan_line_table label word
	x = 0
	REPT 256
	dw	(((x/9)*16)+(x mod 9))*128
	x = x + 1
	ENDM

BIT_TABLE LABEL BYTE
	DB	10000000b
	DB	01000000b
	DB	00100000b
	DB	00010000b
	DB	00001000b
	DB	00000100b
	DB	00000010b
	DB	00000001b

KEYCODE	macro	zcode,pccode
	DB	zcode
	DW	pccode
	endm

;	NOTE: Shift number keys are not represented here because they would
;	cause GETBOX to call Interrupt 10 to switch pages.
KBD_XLAT	LABEL BYTE
	keycode	  27,011BH		; escape
	keycode	  13,1c0dh		; Return
	keycode	08DH,1c0dh		; ENTER (same as RETURN)
	keycode	 '0',0B30h		; '0'
	keycode	 '1',0231h		; '1'
	keycode  '2',0332h		; '2'
	keycode	 '3',0433h		; '3'
	keycode	 '4',0534h		; '4'
	keycode	0a5h,4800h		; UP
	keycode 0a6h,5000h		; DOWN
	keycode	0a7h,4d00h		; RIGHT
	keycode	0a8h,4b00h		; LEFT
	keycode	0e5h,4838h		; Shift-UP
	keycode	0e6h,5032h		; Shift-DOWN
	keycode	0e7h,4d36h		; Shift-RIGHT
	keycode	0e8h,4b34h		; Shift-LEFT
	keycode 0b1h,4f00h		; Keypad '1'
	keycode 0b2h,5000h		; Keypad '2'
	keycode 0b3h,5100h		; Keypad '3'
	keycode 0b4h,4b00h		; Keypad '4'
	keycode 0b6h,4d00h		; Keypad '6'
	keycode 0b7h,4700h		; Keypad '7'
	keycode 0b8h,4800h		; Keypad '8'
	keycode 0b9h,4900h		; Keypad '9'
	keycode 0f1h,4f31h		; Shifted Keypad '1'
	keycode 0f2h,5032h		; Shifted Keypad '2'
	keycode 0f3h,5133h		; Shifted Keypad '3'
	keycode 0f4h,4b34h		; Shifted Keypad '4'
	keycode 0f6h,4d36h		; Shifted Keypad '6'
	keycode 0f7h,4737h		; Shifted Keypad '7'
	keycode 0f8h,4838h		; Shifted Keypad '8'
	keycode 0f9h,4939h		; Shifted Keypad '9'
	keycode	0b0h,5200h		; '0' on Keypad (like 'Ins')
	keycode	0aeh,5300h		; '.' on Keypad (like 'Del')
	keycode	 '+',4e2bh		; '+' key
	keycode	 '-',4a2dh		; '-' key
	keycode	0adh,4a2dh		; '-' on Keypad
	keycode	0a9h,4e2bh		; HOME (emulates '+' key)
	keycode  'p',01970h		; 'p' - Force Portrait
	keycode  'P',01950h		; 'P'
	keycode  'l',0266Ch		; 'l' - Force Landscape
	keycode  'L',0264Ch		; 'L'
	keycode 009h,00f09h		; TAB key
	keycode  '?',0353fh		; Question mark key
	keycode	0,0			; -- end of table--

_DATA	ENDS

_TEXT	SEGMENT
;
;	GETMODE
;	-------
;	Get current video mode.  Returns a 'fake' value of 10 or 11
;	to show Z-100.  (These modes are unused by the PC.)
;	Mode 10: 640x216 (24 lines); Mode 11: 640x225 (25 lines)
;
;	INPUT:	none
;	OUTPUT:	AL	Mode # (10 or 11)
;		AH	Columns in text display (80)
;		BH	Video Page # (0)
;		BL	Rows in text display (25) [unused, always in graphics.]
;	USES:	none
;
GETMODE	PROC	NEAR
	push	es
	xor	ax,ax
	mov	es,ax			; ES=0
	mov	es,es:[03FEH]		; ES = BIOS segment
	mov	al,es:[05H]		; AL = version #
	mov	bx,2			; Added to offsets for ROM 2.0 & up
	cmp	al,020H			; Prior to BIOS 2.0?
	jge	new_bios
	xor	bx,bx			; Yes -- adjust offset
new_bios:
	mov	al,byte ptr es:02DDH[bx] ; Displayed scan lines/character
	mov	scans_char,al

	mov	cl,byte ptr es:02DEH[bx] ; Text lines per screen
	test	byte ptr es:02D9H[bx],0FFH ; Is 25th line enabled?
	jnz	no_25
	dec	cl			; If disabled, one less line/screen
no_25:	mul	cl			; AX = Scan lines/screen
	mov	disp_rows,ax	

	cmp	ax,300			; If # of display rows > 300, use hi-res
	mov	al,Z_MODE		; Z-100 pseudo-mode
	jle	gm_1
	inc	al			; Z-100 Hires (640x480) mode
gm_1:
	mov	video_mode,al		; Save display mode

	mov	al,byte ptr es:02DCH[bx] ; Characters per line (usually 80)
	xor	ah,ah
	shl	ax,1			; * 8 for number of columns
	shl	ax,1
	shl	ax,1
	mov	disp_cols,ax

;	mov	al,byte ptr es:02DFH[bx] ; # of Video planes (1 or 3)
;	cmp	al,3
;	mov	al,0			; For color systems, any color OK
;	jne	gm_1
;	mov	al,7			; Monochrome system - color 7 only
;	mov	MONOCH,al	

	POP	ES
	RETN
GETMODE	ENDP
;
;	Plot a point on the screen.
;
;	Inputs: AX = X coordinate
;		BX = Y coordinate
;		CX = color to plot
;
PLOTPT PROC     NEAR
	push	es
	push	si
	push	dx
	push	cx
	push	bx
; Get color
IF 0
	or	cl,monoch		; Make all Plot's color 7 if mono
ENDIF
	mov	colr,cl
; Get row (Y)
	dec	bx
	mov	cx,bx
; Get col (X)
	dec	ax
	mov	dx,ax

	CALL	GET_ADDRESS

	MOV	CX,01000H		; Increment of video segments
	MOV	BX,0C000H		; First (Blue) plane segment

	; Put complement of bit mask in DH so we can clear bits:

	mov	dh,dl
	not	dh

	; Now set and clear color bits according to color #:

	MOV	ES,BX			; Access first (BLUE) plane
	ADD	BX,CX			; Address of next plane
	TEST	COLR,BLUE		; Set blue bit?
	JZ	NO_BLUE			; No -- must clear it.

	OR	ES:[SI],DL		; Set bit in byte in blue plane
	JMP	SHORT DO_RED

NO_BLUE:
	AND	ES:[SI],DH	

DO_RED:
	MOV	ES,BX			; Access next (RED) plane
	ADD	BX,CX			; Address of next plane

	TEST	COLR,RED
	JZ	NO_RED

	OR	ES:[SI],DL
	JMP	SHORT DO_GREEN

NO_RED:
	AND	ES:[SI],DH	

DO_GREEN:
	MOV	ES,BX			; Access next (GREEN) plane

	TEST	COLR,GREEN
	JZ	NO_GREEN

	OR	ES:[SI],DL
	JMP	SHORT W_DONE

NO_GREEN:
	AND	ES:[SI],DH	

W_DONE:
	pop	bx
	pop	cx
	pop	dx
	pop	si
	pop	es
	retn
PLOTPT	ENDP

;
;	READPT -- Read a pixel from the screen
;
;	Inputs:  AX = X coordinate
;		 BX = Y coordinate
;	Returns: AX is pixel color
;
READPT PROC	NEAR
	push	es
	push	si
	push	dx
	push	cx
	push	bx
; Get row (Y)
	dec	bx
	mov	cx,bx
; Get col (X)
	dec	ax
	mov	dx,ax

	CALL	GET_ADDRESS

;
;	Build return value in AX:
;	00000000 00000nnn
;       -------- --------
;          |        +-------- color # (0..7)
;	   +----------------- 0 indicates non-VGA display
;
	xor	AX,AX			; Put final color # in AL; set AH
					; to 0 to indicate non-VGA display
	MOV	CX,01000H		; Increment of video segments
	MOV	BX,0C000H		; First (Blue) plane segment

;	Now set and clear color bits according to color #:

	MOV	ES,BX			; Access BLUE plane
	TEST	ES:[SI],DL		; Bit set in blue plane?
	JZ	READ_RED

	OR	AL,BLUE			; Set blue bit in color #

READ_RED:
	ADD	BX,CX			; Get next (Red) plane address
	MOV	ES,BX			; Access segment

	TEST	ES:[SI],DL		; Bit set in red plane?
	JZ	READ_GREEN

	OR	AL,RED			; Set red bit in color #

READ_GREEN:
	ADD	BX,CX			; Get next (Green) plane address
	MOV	ES,BX			; Access segment

	TEST	ES:[SI],DL		; Bit set in green plane?
	JZ	R_DONE

	OR	AL,GREEN		; Set green bit in color #

R_DONE:
	pop	bx
	pop	cx
	pop	dx
	pop	si
	pop	es
	retn

READPT	ENDP

GET_ADDRESS PROC NEAR
;
; Because there are nine rows (a "character row") and then a gap of
; seven rows (unused area) in every group of sixteen scan lines,
; we divide the pixel row number by nine; the quotient is the
; 'row' number (of 16) and the remainder is the scan line # within the
; 'group' of rows.
;
;	INPUT:	CX	Row # (0..224)
;		DX	Column # (0..639)
;	OUTPUT:	SI	Offset of pixel in graphics segment
;		DL	Bit mask for pixel
;	USES:	AX, BX
;	SAVES:	CX
;
	push	cx

	cmp	cx,LAST_Y		; same Y coordinate as last time?
	jne	GET_ADDR_NEW		; No -- compute offsets
	mov	bx,LAST_ANS		; Yes -- retrieve 'cached' offset
	jmp	GET_ADDR_OLD		; and skip computation

GET_ADDR_NEW:
	mov	LAST_Y,cx		; Save input value
	mov	ax,cx			; Get pixel row # (0..224)
	mov	cl,scans_char		; Nine visible rows of each 16
	cmp	cl,9
	jne	get_addr_1		; Other than 9 displayed

	shl	ax,1			; Make into word offset
	mov	bx,ax
	mov	bx,scan_line_table[bx]
	jmp	get_addr_got		; Answer is in BX

get_addr_1:
	cmp	cl,16
	jne	get_addr_other

	mov	bx,ax
	mov	cl,7			; Just multiply by 128
	shl	bx,cl
	jmp	get_addr_got

get_addr_other:
	div	cl			; Puts 'row' # in AL, 'scan line' in AH
; Compute offset of start of scan line
	xor	bh,bh
	mov	bl,al			; bx = Row # (0..25)
	shl	bx,1			; Multiply by 16
	shl	bx,1
	shl	bx,1
	shl	bx,1
	or	bl,ah			; Put in the scan line (0..8)

	; Multiply BX by 128:
	shr	bh,1			; Put lsb of BH into Carry
	mov	bh,bl			; Put in BH (multiply by 256)
	mov	bl,0			; BL = 0 (DON'T clear Carry!)
	rcr	bx,1			; shift BX right & fill high bit
					; with carry (from msb of orig. BH)

get_addr_got:
	mov	LAST_ANS,bx		; save answer

GET_ADDR_OLD:
; Find column ('byte') number in SI
	mov	si,dx			; pixel column # (0..639)
	shr	si,1
	shr	si,1
	shr	si,1			; byte # (0..79)

	add	si,bx			; Add byte # to scan-line offset (SI)
	
	mov	bx,offset bit_table	; Translate bit # to bit mask
	mov	al,dl
	and	al,7
	xlat
	mov	dl,al

; Address of byte is now in SI; bit mask is in DL.
	pop	cx
	RETN
GET_ADDRESS ENDP
;
;	RESET the graphics board
;
RESET PROC NEAR
	RETN
RESET	ENDP

KBD_STATPORT	EQU	0F5H		; Keyboard status port
KBD_READY	EQU	00000010B	; Ready bit
KBD_CHAR	EQU	00000001B	; Character present bit

KBD_CMDPORT	EQU	0F5H		; Command port
K_C_ASCII	EQU	0BH		; ASCII scan mode
K_C_INTENA	EQU	0CH		; Enable interrupts
K_C_INTDIS	EQU	0DH		; Disable interrupts
K_C_BEEP	EQU	07H		; Beep!

KBD_INPORT	EQU	0F4H		; Data port address

;
;	KBD_CMD - Send a command to the keyboard processor
;
KBD_CMD	PROC NEAR
	PUSH	AX
K0:	IN	AL,KBD_STATPORT	; Keyboard status port
	TEST	AL,KBD_READY	; Keyboard ready for command?
	JNZ	K0
	POP	AX		; Get command to send
	OUT	KBD_CMDPORT,AL	; Send command
	RETN
KBD_CMD ENDP
;
;	Audible alert -- BEEP
;
BEEP PROC NEAR
	MOV	AL,K_C_BEEP
	CALL	KBD_CMD
	RETN
BEEP	ENDP

;
;	TEST_KBD tells EGAD whether there are any keys waiting
;
TEST_KBD PROC NEAR
	push	ax
	push	bx
	push	cx
	push	dx

	; Direct Keyboard I/O
	IN	AL,KBD_STATPORT
	TEST	AL,KBD_CHAR	; Zero if no characters waiting

	pop	dx
	pop	cx
	pop	bx
	pop	ax
	RETN
TEST_KBD ENDP

;
;	READ_KBD reads a key from the keyboard
;
READ_KBD PROC NEAR
	push	bx
	push	cx
	push	dx
	push	es
	push	si

read_loop:
	; Direct keyboard I/O
	IN	AL,KBD_STATPORT
	TEST	AL,KBD_CHAR
	JZ	read_loop	; No characters -- poll
	IN	AL,KBD_INPORT	; Get character

	mov	bl,al		; Put character into BL

	mov	si,offset kbd_xlat ; Address of key translation table

rd_xlat_loop:
	lodsb			; Get Z-100 style key
	cmp	al,0		; end of table?
	jne	rd_xlat_2

	mov	al,bl		; Put character into AL
	xor	ah,ah		; Set AH=0 (no scan code available)
	jmp	read_exit
	
rd_xlat_2:
	mov	bh,al		; Put this Z-100 key in BH
	lodsw			; Get translation to PC key
	cmp	bh,bl		; Proper translation?
	jne	rd_xlat_loop	; Scan code & char code now in AX.

read_exit:
	pop	si
	pop	es
	pop	dx
	pop	cx
	pop	bx

	RETN
READ_KBD ENDP

KBD_SETUP PROC NEAR
	push	es
	push	ax
	push	bx

	; Direct keyboard I/O
	mov	al,K_C_INTDIS		; Disable keyboard interrupts
	call	KBD_CMD

	; Read and save current video RAM register
	in	al,VPORT
	mov	vram,al

	; now set to write only in selected planes:
	mov	al,078h			; Enable VRAM; no write-through;
	out	VPORT,al		; screen appears normally.

	pop	bx
	pop	ax
	pop	es
	retn
KBD_SETUP ENDP

;
;	KBD_RESET restores the key expansion flag, and resets
;	any other graphic modes which were changed.
;	Called when EGAD is all done.
;
KBD_RESET PROC NEAR
	push	es
	push	ax
	push	bx
	mov	al,K_C_INTENA		; Re-enable keyboard interrupts
	CALL	KBD_CMD

	; restore VPORT value
	mov	al,vram			; Restore video RAM access mode
	out	VPORT,al

	pop	bx
	pop	ax
	pop	es
	retn
KBD_RESET ENDP


_TEXT	ENDS
	END
